const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const performance_reviews = sequelize.define(
    'performance_reviews',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

review_date: {
        type: DataTypes.DATE,
      
      

      },

score: {
        type: DataTypes.DECIMAL,
      
      

      },

summary: {
        type: DataTypes.TEXT,
      
      

      },

goals: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  performance_reviews.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.performance_reviews.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.performance_reviews.belongsTo(db.users, {
      as: 'reviewer',
      foreignKey: {
        name: 'reviewerId',
      },
      constraints: false,
    });

    db.performance_reviews.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.performance_reviews.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.performance_reviews.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return performance_reviews;
};


